unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  FileName: string;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    FileName:=OpenDialog1.FileName;
    Caption:=FileName;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  srcfile, tgtfile: file of byte;
  pix: record b,g,r: byte; end;
  n, cl: byte;
  s, ls, i: integer;
  tgtsize, bmsize: dword;
begin
  AssignFile(srcfile, UTF8ToSys(FileName));
  Reset(srcfile);
  AssignFile(tgtfile, UTF8ToSys(Edit1.Text));
  Rewrite(tgtfile);
  Seek(tgtfile, 8);
  tgtsize:=8;
  bmsize:=3;
  Seek(srcfile, 54);
  n:=1;
  Read(srcfile, pix.b);
  Read(srcfile, pix.g);
  Read(srcfile, pix.r);
  ls:=pix.r*256*256 + pix.g*256 + pix.b;
  cl:=(pix.r and 224) +  ((pix.g shr 3) and 28) + (pix.b shr 6);
  while not Eof(srcfile) do
  begin
    Read(srcfile, pix.b);
    Read(srcfile, pix.g);
    Read(srcfile, pix.r);
    bmsize:=bmsize + 3;
    s:=pix.r*256*256 + pix.g*256 + pix.b;
    n:=n+1;
    if (s<>ls) or (n=0)then
    begin
       Write(tgtfile,n-1);
       Write(tgtfile,cl);
       tgtsize:=tgtsize+2;
       n:=1;
    end;
    cl:=(pix.r and 224) +  ((pix.g shr 3) and 28) + (pix.b shr 6);
    ls:=s;
  end;
  Write(tgtfile,n);
  Write(tgtfile,cl);
  tgtsize:=tgtsize+2;
  Seek(tgtfile, 0);
  Caption:=IntToStr(tgtsize)+' '+IntToStr(bmsize);
  Write(tgtfile,(tgtsize and $000000FF));
  Write(tgtfile,(tgtsize and $0000FF00)shr 8);
  Write(tgtfile,(tgtsize and $00FF0000)shr 16);
  Write(tgtfile,(tgtsize and $FF000000)shr 24);
  Write(tgtfile,(bmsize and $000000FF));
  Write(tgtfile,(bmsize and $0000FF00)shr 8);
  Write(tgtfile,(bmsize and $00FF0000)shr 16);
  Write(tgtfile,(bmsize and $FF000000)shr 24);
  CloseFile(tgtfile);
  CloseFile(srcfile);
end;



end.

